import 'package:json_annotation/json_annotation.dart';
import 'package:libaqueous/src/api/events/model/unsigned_data.dart';

part 'room_member.g.dart';

@JsonSerializable()
class RoomMember {
  static const String MEMBERSHIP_JOIN = "join";
  static const String MEMBERSHIP_INVITE = "invite";
  static const String MEMBERSHIP_LEAVE = "leave";
  static const String MEMBERSHIP_BAN = "ban";

  static const String MEMBERSHIP_KICK = "kick";

  @JsonKey(name: "membership")
  String membership;

  @JsonKey(name: "displayname")
  String displayName;

  @JsonKey(name: "avatar_url")
  String avatarUrl;

  @JsonKey(name: "is_direct")
  bool isDirect = false;

  @JsonKey(name: "unsigned")
  UnsignedData unsignedData;

  static const fromJson = _$RoomMemberFromJson;

  Map<String, dynamic> toJson() => _$RoomMemberToJson(this);
}
