import 'package:libaqueous/src/api/events/model/event.dart';
import 'package:libaqueous/src/api/room/model/room_member.dart';

class RoomState {
  String roomID;
  String name;
  String topic;
  Uri avatarUrl;
  Event latestReceivedEvent;

  String readReceiptEventID;
  String readMarkerEventID;

  Set<String> roomTags;

  int unreadEventsCount;
  int notificationCount;
  int highlightsCount;

  String inviterUserID;
  String inviterName;

  String userID;
  String userMembership;

  List<String> aliases = [];
  String canonicalAlias;

  int joinedMembersCountFromSyncRoomSummary;
  int invitedMembersCountFromSyncRoomSummary;

  bool isDirect = false;
  String directUserID;

  // TODO: Check if event is supported.
  static bool isSupportedEvent(Event event) => true;

  bool get isInvited => userMembership == RoomMember.MEMBERSHIP_INVITE;

  bool get isJoined => userMembership == RoomMember.MEMBERSHIP_JOIN;
}
